using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace WinGrid_cs_62_CLR2_SingleSelection
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable("Customer");
            dt.Columns.Add("CustomerID", typeof(int));
            dt.Columns.Add("CustomerName", typeof(string));
            dt.Columns.Add("Address", typeof(string));
            dt.Columns.Add("DateOfJoin", typeof(DateTime));
            dt.Columns.Add("Check", typeof(String));
            dt.Rows.Add(new object[] { 1, "John Lever", "South Street", DateTime.Now,"false" });
            dt.Rows.Add(new object[] { 2, "Walter Smith", "12/4 S MarkD", DateTime.Now, "true" });
            dt.Rows.Add(new object[] { 3, "Kathy Lever", "23/45 Honai", DateTime.Now, "false" });
            dt.Rows.Add(new object[] { 4, "George Wills", "233 Walter Street", DateTime.Now, "false" });
            this.ultraGrid1.DataSource = dt;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Check"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Check"].CellDisplayStyle = Infragistics.Win.UltraWinGrid.CellDisplayStyle.PlainText;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Check"].Editor.DataFilter = new CheckEditorDataFilter();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SelectedRowAppearance.BackColor = Color.Beige;
            e.Layout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.EditAndSelectText;
            e.Layout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.ExtendedAutoDrag;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show(this.ultraGrid1.Selected.Rows.Count.ToString());
            
            this.ultraGrid1.Selected.Rows.Clear();
            this.ultraGrid1.Rows[0].Activate();
            this.ultraGrid1.Rows[0].Activated = true;
            this.ultraGrid1.Rows[0].Selected = true;
            //this.ultraGrid1.Selected.Rows.Add(this.ultraGrid1.Rows[0]);

        }
    }

    class CheckEditorDataFilter : Infragistics.Win.IEditorDataFilter
    {
        object Infragistics.Win.IEditorDataFilter
            .Convert(Infragistics.Win.EditorDataFilterConvertArgs args)
        {
            switch (args.Direction)
            {
                case ConversionDirection.EditorToOwner:
                    args.Handled = true;
                    if (args.Value.ToString() == "Checked")
                        return "Y";
                    else
                        return "N";
                case ConversionDirection.OwnerToEditor:
                    args.Handled = true;
                    if (args.Value.ToString() == "Y")
                        return
((Infragistics.Win.CheckEditor)(args.Editor)).
                            CheckState = CheckState.Checked;
                    else
                        return
((Infragistics.Win.CheckEditor)(args.Editor)).
                            CheckState = CheckState.Unchecked;

            }
            return args.Value;
        }
    }

}